﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Agis
{
    public partial class Form8 : Form
    {
        [DllImport("user32.dll", EntryPoint = "GetSystemMetrics")]
        public static extern int GetSystemMetrics(int nIndex);

        [DllImport("user32.dll")]
        static extern bool SetForegroundWindow(IntPtr hWnd);

        [DllImport("user32.dll")]
        static extern void mouse_event(uint dwFlags, int dx, int dy, uint dwData, int dwExtraInfo);

        [DllImport("user32.dll")]
        static extern bool SetCursorPos(int X, int Y);

        [DllImport("user32.dll")]
        private static extern IntPtr GetForegroundWindow();

        public const int MOUSEEVENTF_LEFTDOWN = 0x02;
        public const int MOUSEEVENTF_LEFTUP = 0x04;
        public const int MOUSEEVENTF_RIGHTDOWN = 0x08;
        public const int MOUSEEVENTF_RIGHTUP = 0x10;

        public StringBuilder sb = null;
        private int clickX;
        private int clickY;
        private int capture = 0;
        private int index = 0;
        IntPtr agis;
        private List<List<string>> prikazy;

        public Form8(List<List<string>> prikazy)
        {
            InitializeComponent();
            this.prikazy = prikazy;
        }
        private int setCapture(string l)
        {
            if (l[1] == 'm')
                return 0;
            else if (l[1] == 'l')
            {
                if (l[2] == 'd')
                    return 1;
                else
                    return 2;
            }
            else
            {
                if (l[2] == 'd')
                    return 3;
                else
                    return 4;
            }
        }
        private void Form8_Load(object sender, EventArgs e)
        {
            this.Size = new Size(GetSystemMetrics(0), GetSystemMetrics(1));
            this.BackColor = Color.FromArgb(255, 255, 255, 255);
            this.TransparencyKey = Color.FromArgb(255, 255, 255, 255);
            int x = GetSystemMetrics(0) / 2;
            int y = GetSystemMetrics(1) / 2;
            Process[] p = Process.GetProcessesByName("ArcMap");
            try
            {
                agis = p[0].MainWindowHandle;
                SetForegroundWindow(agis);
                System.Threading.Thread.Sleep(1000);
                SetForegroundWindow(this.Handle);
            }
            catch (Exception ex)
            {
            }
            sb = new StringBuilder();
            this.TopMost = true;
            this.Refresh();
            start();
        }

        private void start()
        {
            for (int i = this.index; i < this.prikazy.Count; i++)
            {
                mouseCapture.UnhookWindowsHookEx(mouseCapture.getHook());
                keyboardCapture.UnhookWindowsHookEx(keyboardCapture.getHook());
                foreach (string s in prikazy[i])
                {
                    if (s.StartsWith("K"))
                    {
                        sb.AppendLine(s);
                        SendKeys.SendWait(s.Substring(3, s.Length - 3));
                        index += 1;
                        start();
                    }
                    else if (s.StartsWith("T"))
                    {
                        string rad = s.Substring(3, s.Length - 3);
                        string[] splBy = { "////" };
                        string[] splited = rad.Split(splBy, StringSplitOptions.None);
                        Form3 f3 = new Form3(1);
                        f3.Show();
                        f3.changeLabelText(splited[0]);
                        f3.changeLabelPosition(int.Parse(splited[1]), int.Parse(splited[2]));
                        ColorConverter cc = new ColorConverter();
                        Color c = (Color)cc.ConvertFromString(splited[3]);
                        FontConverter fc = new FontConverter();
                        Font f = (Font)fc.ConvertFromString(splited[4]);
                        f3.changeLabelColor(c);
                        f3.changeLabelFont(f);
                        f3.changeLabelTag(int.Parse(splited[5]));
                        f3.addText();
                        sb.AppendLine(f3.sb.ToString());
                        f3.Dispose();
                        f3 = null;
                        index += 1;
                        start();
                    }
                    else
                    {
                        mouseCapture.setHook(mouseCapture.SetHook(mouseCapture.getProc()));
                        keyboardCapture.setHook(keyboardCapture.SetHook(keyboardCapture.getProc()));
                        show();
                        return;
                    }

                }
            }
            this.Close();
        }


        internal void setClick(int x, int y, mouseCapture.MouseMessages m)
        {
            clickX = x;
            clickY = y;
            if (m == mouseCapture.MouseMessages.WM_LBUTTONDOWN && this.capture == 1)
                addLDMouse();
            if (m == mouseCapture.MouseMessages.WM_LBUTTONUP && this.capture == 2)
                addLUMouse();
            if (m == mouseCapture.MouseMessages.WM_RBUTTONDOWN && this.capture == 3)
                addRDMouse();
            if (m == mouseCapture.MouseMessages.WM_RBUTTONUP && this.capture == 4)
                addRUMouse();
            if (m == mouseCapture.MouseMessages.WM_MOUSEMOVE && this.capture == 0)
                addMMouse();
        }
        private void addMMouse()
        {
            if (sb != null)
                sb.AppendLine("Mm " + clickX + "," + clickY);

        }
        private void addLDMouse()
        {
            if (sb != null)
                sb.AppendLine("Mld" + clickX + "," + clickY);

        }
        private void addLUMouse()
        {
            if (sb != null)
                sb.AppendLine("Mlu" + clickX + "," + clickY);

        }
        private void addRDMouse()
        {
            if (sb != null)
                sb.AppendLine("Mrd" + clickX + "," + clickY);

        }
        private void addRUMouse()
        {
            if (sb != null)
                sb.AppendLine("Mru" + clickX + "," + clickY);
        }
        internal void setClickKey(Keys k)
        {
            switch (k)
            {
                case (Keys.F1):
                    {
                        show();
                        break;
                    }
                case (Keys.F2):
                    {
                        if (index < this.prikazy.Count)
                        {
                            foreach (string s in this.prikazy[index])
                            {
                                sb.AppendLine(s);
                            }
                            index += 1;
                            start();
                        }
                        break;
                    }
                case (Keys.F3):
                    {
                        int clX = int.Parse(this.prikazy[index][0].Substring(3, this.prikazy[index][0].IndexOf(",") - 3));
                        int clY = int.Parse(this.prikazy[index][0].Substring(this.prikazy[index][0].IndexOf(",") + 1, this.prikazy[index][0].Length - this.prikazy[index][0].IndexOf(",") - 1));
                        SetCursorPos(clX, clY);
                        capture = setCapture(this.prikazy[index][0]);
                        break;
                    }
                case (Keys.F12):
                    {
                        if (capture != 5)
                        {
                            capture = 5;
                            index += 1;
                            start();
                        }
                        break;
                    }
                default:
                    {
                        break;
                    }
            }
        }
        internal void show()
        {
            Process[] p = Process.GetProcessesByName("ArcMap");
            try
            {
                agis = p[0].MainWindowHandle;
            }
            catch (Exception ex)
            {
                MessageBox.Show("ArcGis není spuštěn, není možné spustit makro");
            }
            System.Threading.Thread.Sleep(1000);
            foreach (string pr in this.prikazy[index])
            {
                if (pr != "")
                {
                    runCommand(pr, GetSystemMetrics(0), GetSystemMetrics(1));
                }
            }
        }

        private void runCommand(string pr, int r1, int r2)
        {
            switch (pr[0])
            {
                case 'M':
                    {
                        int clX = int.Parse(pr.Substring(3, pr.IndexOf(",") - 3));
                        int clY = int.Parse(pr.Substring(pr.IndexOf(",") + 1, pr.Length - pr.IndexOf(",") - 1));
                        SetCursorPos(clX, clY);
                        if (pr[1] == 'm')
                        {
                            System.Threading.Thread.Sleep(1);
                        }
                        else if (pr[1] == 'l')
                        {
                            if (pr[2] == 'd')
                            {
                                System.Threading.Thread.Sleep(10);
                                mouse_event(MOUSEEVENTF_LEFTDOWN, Cursor.Position.X, Cursor.Position.Y, 0, 0);
                            }
                            else
                            {
                                mouse_event(MOUSEEVENTF_LEFTUP, Cursor.Position.X, Cursor.Position.Y, 0, 0);
                                System.Threading.Thread.Sleep(1000);
                            }
                        }
                        else
                        {
                            if (pr[2] == 'd')
                            {
                                System.Threading.Thread.Sleep(10);
                                mouse_event(MOUSEEVENTF_RIGHTDOWN, Cursor.Position.X, Cursor.Position.Y, 0, 0);
                            }
                            else
                            {
                                mouse_event(MOUSEEVENTF_RIGHTUP, Cursor.Position.X, Cursor.Position.Y, 0, 0);
                                System.Threading.Thread.Sleep(1000);
                            }
                        }
                        System.Threading.Thread.Sleep(1);
                        break;
                    }
                default:
                    {
                        break;
                    }
            }
        }
    }
}
