﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Agis
{
    public partial class Form4 : Form
    {
        [DllImport("user32.dll", EntryPoint = "GetSystemMetrics")]
        public static extern int GetSystemMetrics(int nIndex);

        [DllImport("user32.dll")]
        static extern bool SetForegroundWindow(IntPtr hWnd);

        private Form3 parrent;


        private string p;


        public Form4(Form3 form3, Font font, Color color, string p, Point point, string t)
        {
            InitializeComponent();
            this.parrent = form3;
            textBox3.Text = font.ToString();
            fontDialog1.Font = font;
            button1.BackColor = color;
            colorDialog1.Color = color;
            textBox1.Text = point.X.ToString();
            textBox2.Text = point.Y.ToString();
            text.Text = p;
            time.Text = t;
        }



        private void Form4_Load(object sender, EventArgs e)
        {
            text.Select();
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            int set = trackBar1.Value - 50;
            int x = int.Parse(textBox1.Text);
            int res = x + set;
            if (res < 0)
                res = 0;
            if (res > GetSystemMetrics(0))
                res = GetSystemMetrics(0);
            textBox1.Text = res.ToString();
            parrent.changeLabelPosition(int.Parse(textBox1.Text), int.Parse(textBox2.Text));
        }

        private void trackBar2_Scroll(object sender, EventArgs e)
        {
            int set = trackBar2.Value - 50;
            int y = int.Parse(textBox2.Text);
            int res = y + set;
            if (res < 0)
                res = 0;
            if (res > GetSystemMetrics(1))
                res = GetSystemMetrics(1);
            textBox2.Text = res.ToString();
            parrent.changeLabelPosition(int.Parse(textBox1.Text), int.Parse(textBox2.Text));
        }

        private void textBox1_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                int.Parse(textBox1.Text).ToString();
            }
            catch (Exception ex)
            {
                int i = (int)(GetSystemMetrics(0) / 2);
                textBox1.Text = i.ToString();
            }
        }

        private void textBox2_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                int.Parse(textBox2.Text).ToString();
            }
            catch (Exception ex)
            {
                int i = (int)(GetSystemMetrics(1) / 2);
                textBox2.Text = i.ToString();
            }
        }
        private void time_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                int.Parse(time.Text).ToString();
            }
            catch (Exception ex)
            {
                int i = 0;
                time.Text = i.ToString();
            }
        }
        private void textBox1_Validated(object sender, EventArgs e)
        {
            parrent.changeLabelPosition(int.Parse(textBox1.Text), int.Parse(textBox2.Text));
        }

        private void textBox2_Validated(object sender, EventArgs e)
        {
            parrent.changeLabelPosition(int.Parse(textBox1.Text), int.Parse(textBox2.Text));
        }

        private void time_Validated(object sender, EventArgs e)
        {
            parrent.changeLabelTag(int.Parse(time.Text));
        }

        private void OK_Click(object sender, EventArgs e)
        {

            if (text.Text.Contains('\n'))
            {
                text.Text = text.Text.Replace("\n", "/++/");
            }
            parrent.changeLabelPosition(int.Parse(textBox1.Text), int.Parse(textBox2.Text));
            parrent.changeLabelText(text.Text);
            parrent.changeLabelColor(colorDialog1.Color);
            parrent.changeLabelFont(fontDialog1.Font);
            parrent.changeLabelTag(int.Parse(time.Text));
            SetForegroundWindow(parrent.Handle);
            this.Dispose();
        }

        private void cancel_Click(object sender, EventArgs e)
        {
            parrent.changeLabelText("");
            parrent.changeLabelPosition(0, 0);
            this.Dispose();
        }

        private void text_TextChanged(object sender, EventArgs e)
        {
            if (time.Text.Equals("0") && !text.Text.EndsWith(",pokračujte stisknutím ENTERu"))
            {
                int ind = text.SelectionStart;
                text.Text = text.Text + ",pokračujte stisknutím ENTERu";
                text.Select(ind, 0);
            }
            parrent.changeLabelText(text.Text);
        }

        private void trackBar1_MouseUp(object sender, MouseEventArgs e)
        {
            trackBar1.Value = 50;
        }

        private void trackBar2_MouseUp(object sender, MouseEventArgs e)
        {
            trackBar2.Value = 50;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            colorDialog1.ShowDialog();
            button1.BackColor = colorDialog1.Color;
            parrent.changeLabelColor(colorDialog1.Color);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            fontDialog1.ShowDialog();
            textBox3.Text = fontDialog1.Font.ToString();
            parrent.changeLabelFont(fontDialog1.Font);
        }
    }
}
